1 #!/bin/sh
   2 
   3 # Copyright (c) 2007, 2016, Oracle and/or its affiliates. All rights reserved.
   4 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
   5 #
   6 # This code is free software; you can redistribute it and/or modify it
   7 # under the terms of the GNU General Public License version 2 only, as
   8 # published by the Free Software Foundation.
   9 #
  10 # This code is distributed in the hope that it will be useful, but WITHOUT
  11 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  12 # FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  13 # version 2 for more details (a copy is included in the LICENSE file that
  14 # accompanied this code).
  15 #
  16 # You should have received a copy of the GNU General Public License version
  17 # 2 along with this work; if not, write to the Free Software Foundation,
  18 # Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
  19 #
  20 # Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
  21 # or visit www.oracle.com if you need additional information or have any
  22 # questions.
  23 #
  24 
  25 # @test
  26 # @bug 6332666 6863624 7180362 8003846 8074350 8074351 8130246 8149735
  27 # @summary tests the capability of replacing the currency data with user
  28 #     specified currency properties file
  29 # @build PropertiesTest
  30 # @run shell/timeout=600 PropertiesTest.sh
  31 
  32 if [ "${TESTSRC}" = "" ]
  33 then
  34   echo "TESTSRC not set.  Test cannot execute.  Failed."
  35   exit 1
  36 fi
  37 echo "TESTSRC=${TESTSRC}"
  38 if [ "${TESTJAVA}" = "" ]
  39 then
  40   echo "TESTJAVA not set.  Test cannot execute.  Failed."
  41   exit 1
  42 fi
  43 echo "TESTJAVA=${TESTJAVA}"
  44 if [ "${TESTCLASSES}" = "" ]
  45 then
  46   echo "TESTCLASSES not set.  Test cannot execute.  Failed."
  47   exit 1
  48 fi
  49 echo "TESTCLASSES=${TESTCLASSES}"
  50 echo "CLASSPATH=${CLASSPATH}"
  51 
  52 # set platform-dependent variables
  53 OS=`uname -s`
  54 case "$OS" in
  55   SunOS | Linux | Darwin | AIX )
  56     PS=":"
  57     FS="/"
  58     ;;
  59   Windows* )
  60     PS=";"
  61     FS="/"
  62     ;;
  63   CYGWIN* )
  64     PS=";"
  65     FS="/"
  66     TESTJAVA=`cygpath -u ${TESTJAVA}`
  67     ;;
  68   * )
  69     echo "Unrecognized system!"
  70     exit 1;
  71     ;;
  72 esac
  73 
  74 failures=0
  75 
  76 run() {
  77     echo ''
  78     ${TESTJAVA}${FS}bin${FS}java ${TESTVMOPTS} -cp ${TESTCLASSES} $* 2>&1
  79     if [ $? != 0 ]; then failures=`expr $failures + 1`; fi
  80 }
  81 
  82 PROPS=${TESTSRC}${FS}currency.properties
  83 
  84 
  85 # Dump built-in currency data
  86 
  87 run PropertiesTest -d dump1
  88 if [ ! -f dump1 ]; then  echo "file dump1 not created. Test cannot execute.  Failed."; exit 1; fi
  89 
  90 # Dump built-in currency data + overrides in properties file specified
  91 # by system property.
  92 
  93 run -Djava.util.currency.data=${PROPS} PropertiesTest -d dump2
  94 if [ ! -f dump2 ]; then  echo "file dump2 not created. Test cannot execute.  Failed."; exit 1; fi
  95 run PropertiesTest -c dump1 dump2 ${PROPS}
  96 
  97 
  98 # Dump built-in currency data + overrides in properties file copied into
  99 # JRE image.
 100 
 101 # Make a private copy of the jdk so we can write to the properties file location
 102 # without disturbing other users, including concurrently executing tests.
 103 WRITABLEJDK=.${FS}testjava
 104 cp -H -R $TESTJAVA $WRITABLEJDK || exit 1
 105 PROPLOCATION=${WRITABLEJDK}${FS}lib
 106 chmod -R a+rx $WRITABLEJDK || exit 1
 107 cp ${PROPS} $PROPLOCATION || exit 1
 108 echo "Properties location: ${PROPLOCATION}"
 109 
 110 # run
 111 echo ''
 112 ${WRITABLEJDK}${FS}bin${FS}java ${TESTVMOPTS} -cp ${TESTCLASSES} PropertiesTest -d dump3
 113 if [ $? != 0 ]; then failures=`expr $failures + 1`; fi
 114 if [ ! -f dump3 ]; then  echo "file dump3 not created. Test cannot execute.  Failed."; exit 1; fi
 115 
 116 # Cleanup
 117 rm -rf $WRITABLEJDK
 118 
 119 # compare the two dump files
 120 run PropertiesTest -c dump1 dump3 ${PROPS}
 121 
 122 
 123 # Results
 124 echo ''
 125 if [ $failures -gt 0 ];
 126   then echo "$failures tests failed";
 127   else echo "All tests passed"; fi
 128 exit $failures